//
//  Copyright (C) by S.Tomabechi 1995
//  All rights reserved.
//    ,
//   (2) vZ
//  ΐvẐŔɒx
//                 ,
//  Iɂ́A-(2) vZ
//
//
#include <fstream.h>
#include <iostream.h>
#include <iomanip.h>
#include "Fint.hpp"
#include "Error.hpp"

Fint dzeta2(int precision)
{
  precision=GetPrecision()>precision ? GetPrecision():precision ;

  unsigned long k ;
  long j ;
  long sign(1) ;
  int nBn ;
  Fint z ;
  Mint ak(0) ;        // <-> a(k)
  Mint kf(1) ;        // factorial
  Fint x ;
                                           // Bernoulli  table
  char filename[]=".\\bernoull.tbl" ;
  ifstream inf(filename,ios::binary) ;     // binary file
  if( inf.bad() ) {
    cerr << endl << "Error : could not open file " << filename ;
    Error(file not found) ;
  }

  Fint ln(precision+1,precision) ;

  long nl(1) ;
  nl<<=6 ;            // n1=2^6

  x=nl ;
  ln=log(x) ;
  z=(ln+1)/x ;
  z += (ln/(x*x))/2 ;
  x[precision-x.fdigit()] ;
  for( j=1 ; j<nl ; j++ ) {   // ̃[v̏x̂
    x=j ;                     // [v̉񐔂܂傫Ă͂ȂȂ
    z += log(x)/(j*j) ;
  }

  Mint n(nl) ;
  Mint n2 ;
  Fint fx ;
  short ishift1(10),ishift2(0) ;

  (n2=n) *= n ;           // n2=n*n


  Mint d ;
  Fint B1 ;
  B1[precision-B1.fdigit()] ;
  Mint num ;

                                          // BernoulliWǂݍ
  inf.read((char*)&nBn ,sizeof(nBn)) ;    // Bernoullǐ
  read(inf,num) ;
  read(inf,d) ;
  for( j=1 ; j<nBn ; j++) {

    kf *= 2*j-1 ;
    sign = -sign ;
    read(inf,num) ;                       // Bernoulli ̕q
    B1=num ;
    read(inf,d) ;                         // Bernoulli ̕

    n *= n2 ;
    while( n.ndigit()>1 ) {
      n>>=ishift1;
      ishift2 += ishift1 ;
    }
    ak *= -(2*j) ;
    ak += kf ;
    kf *= 2*j ;
    fx=ak-kf*ln ;              // W
    ak *= -(2*j+1) ;
    ak -= kf ;
    d *= n ;
    d *= kf ;                  // K

    B1 /= d ;
    B1>>=ishift2 ;
    B1 *= fx ;
    if( (B1>>long(32))==0 ) break ;
    if( sign>0 ) z += B1 ;
    else z -= B1 ;

  }

  inf.close() ;
  return ~z[-(z.fdigit()-precision)] ;
}
