//
//  Copyright (C) by S.Tomabechi 1996
//  All rightsreserved.
//
//  VC++ p̊֐
//  BC++ ł́Aconstream class ̊֐ŎĂ
//
#ifndef __BORLANDC__
#ifdef WIN32 
#include <conio.h>
#include <Windows.h>

//
//  return cursor position
//
int wherey(void)
{
    HANDLE hStdOut ;
    CONSOLE_SCREEN_BUFFER_INFO BufInfo ;
    hStdOut=GetStdHandle(STD_OUTPUT_HANDLE) ;
    GetConsoleScreenBufferInfo(hStdOut,&BufInfo) ;
    return BufInfo.dwCursorPosition.Y ;
}

//
//  return cursor position in console
//
int wherex(void)
{
    HANDLE hStdOut ;
    CONSOLE_SCREEN_BUFFER_INFO BufInfo ;
    hStdOut=GetStdHandle(STD_OUTPUT_HANDLE) ;
    GetConsoleScreenBufferInfo(hStdOut,&BufInfo) ;
    return BufInfo.dwCursorPosition.X ;
}

//
// clear console
//
void clrscr(void)
{
    HANDLE hStdOut = GetStdHandle(STD_OUTPUT_HANDLE);
    COORD coordScreen = { 0, 0 };    /* here's where we'll home the
                                       cursor */
   DWORD cCharsWritten;
   CONSOLE_SCREEN_BUFFER_INFO csbi; /* to get buffer info */
   DWORD dwConSize;                 /* number of character cells in
                                       the current buffer */

   /* get the number of character cells in the current buffer */

   GetConsoleScreenBufferInfo( hStdOut, &csbi );
   dwConSize = csbi.dwSize.X * csbi.dwSize.Y;

   /* fill the entire screen with blanks */

   FillConsoleOutputCharacter( hStdOut, (TCHAR) ' ',
      dwConSize, coordScreen, &cCharsWritten );

   /* get the current text attribute */

   GetConsoleScreenBufferInfo( hStdOut, &csbi );

   /* now set the buffer's attributes accordingly */

   FillConsoleOutputAttribute( hStdOut, csbi.wAttributes,
      dwConSize, coordScreen, &cCharsWritten );

   /* put the cursor at (0, 0) */

   SetConsoleCursorPosition( hStdOut, coordScreen );
}

//
// clear console
//
void delline(void)
{
   HANDLE hStdOut = GetStdHandle(STD_OUTPUT_HANDLE);
   COORD coordScreen ;    /* here's where we'll home the
                                       cursor */
   coordScreen.X=wherex() ;
   coordScreen.Y=wherey() ;

   DWORD cCharsWritten;
   CONSOLE_SCREEN_BUFFER_INFO csbi; /* to get buffer info */
   DWORD dwConSize;                 /* number of character cells in
                                       the current buffer */

   /* get the number of character cells in the current buffer */

   GetConsoleScreenBufferInfo( hStdOut, &csbi );
   dwConSize = csbi.dwSize.X * csbi.dwSize.Y;

   /* fill the entire screen with blanks */

   FillConsoleOutputCharacter( hStdOut, (TCHAR) ' ',
      csbi.dwSize.X, coordScreen, &cCharsWritten );

   /* get the current text attribute */

   GetConsoleScreenBufferInfo( hStdOut, &csbi );

   /* now set the buffer's attributes accordingly */

   FillConsoleOutputAttribute( hStdOut, csbi.wAttributes,
      dwConSize, coordScreen, &cCharsWritten );

   /* put the cursor at current position */

   SetConsoleCursorPosition( hStdOut, coordScreen );
}

//
//  move cursor to position (x,y)
//
void gotoxy(int x,int y)
{
   HANDLE hStdOut ;
   COORD coordScreen ;
   hStdOut=GetStdHandle(STD_OUTPUT_HANDLE) ;
   coordScreen.X=x ;
   coordScreen.Y=y ;
   SetConsoleCursorPosition( hStdOut, coordScreen );
}
#else   // for Linux 
//
//  return cursor position
//
int wherey(void)
{
    HANDLE hStdOut ;
    CONSOLE_SCREEN_BUFFER_INFO BufInfo ;
    hStdOut=GetStdHandle(STD_OUTPUT_HANDLE) ;
    GetConsoleScreenBufferInfo(hStdOut,&BufInfo) ;
    return BufInfo.dwCursorPosition.Y ;
}

//
//  return cursor position in console
//
int wherex(void)
{
    HANDLE hStdOut ;
    CONSOLE_SCREEN_BUFFER_INFO BufInfo ;
    hStdOut=GetStdHandle(STD_OUTPUT_HANDLE) ;
    GetConsoleScreenBufferInfo(hStdOut,&BufInfo) ;
    return BufInfo.dwCursorPosition.X ;
}

//
// clear console
//
void clrscr(void)
{
    HANDLE hStdOut = GetStdHandle(STD_OUTPUT_HANDLE);
    COORD coordScreen = { 0, 0 };    /* here's where we'll home the
                                       cursor */
   DWORD cCharsWritten;
   CONSOLE_SCREEN_BUFFER_INFO csbi; /* to get buffer info */
   DWORD dwConSize;                 /* number of character cells in
                                       the current buffer */

   /* get the number of character cells in the current buffer */

   GetConsoleScreenBufferInfo( hStdOut, &csbi );
   dwConSize = csbi.dwSize.X * csbi.dwSize.Y;

   /* fill the entire screen with blanks */

   FillConsoleOutputCharacter( hStdOut, (TCHAR) ' ',
      dwConSize, coordScreen, &cCharsWritten );

   /* get the current text attribute */

   GetConsoleScreenBufferInfo( hStdOut, &csbi );

   /* now set the buffer's attributes accordingly */

   FillConsoleOutputAttribute( hStdOut, csbi.wAttributes,
      dwConSize, coordScreen, &cCharsWritten );

   /* put the cursor at (0, 0) */

   SetConsoleCursorPosition( hStdOut, coordScreen );
}

//
// clear console
//
void delline(void)
{
   HANDLE hStdOut = GetStdHandle(STD_OUTPUT_HANDLE);
   COORD coordScreen ;    /* here's where we'll home the
                                       cursor */
   coordScreen.X=wherex() ;
   coordScreen.Y=wherey() ;

   DWORD cCharsWritten;
   CONSOLE_SCREEN_BUFFER_INFO csbi; /* to get buffer info */
   DWORD dwConSize;                 /* number of character cells in
                                       the current buffer */

   /* get the number of character cells in the current buffer */

   GetConsoleScreenBufferInfo( hStdOut, &csbi );
   dwConSize = csbi.dwSize.X * csbi.dwSize.Y;

   /* fill the entire screen with blanks */

   FillConsoleOutputCharacter( hStdOut, (TCHAR) ' ',
      csbi.dwSize.X, coordScreen, &cCharsWritten );

   /* get the current text attribute */

   GetConsoleScreenBufferInfo( hStdOut, &csbi );

   /* now set the buffer's attributes accordingly */

   FillConsoleOutputAttribute( hStdOut, csbi.wAttributes,
      dwConSize, coordScreen, &cCharsWritten );

   /* put the cursor at current position */

   SetConsoleCursorPosition( hStdOut, coordScreen );
}

//
//  move cursor to position (x,y)
//
void gotoxy(int x,int y)
{
   HANDLE hStdOut ;
   COORD coordScreen ;
   hStdOut=GetStdHandle(STD_OUTPUT_HANDLE) ;
   coordScreen.X=x ;
   coordScreen.Y=y ;
   SetConsoleCursorPosition( hStdOut, coordScreen );
}

#endif

#endif
