//
//  Copyright (C) by S.Tomabechi 1994,1995
//  All rights reserved.
//
//  return inverse of a mod p
//
//  ax=1 mod p ƂȂ x ߂
//  ݂ȂƂ́A0Ԃ.
//  p ͑fłȂĂ悢
//
#ifdef __BORLANDC__
#pragma inline
#endif
long invmodp(const long a,const long p)
{

  long v1(0) ;
  long v3 ;
  long t3 ;

  __asm {
    mov ebx,p
//    cmp ebx,0
//    je set_zero
    or ebx,ebx
    jz set_zero
    jg Check_a
    neg ebx                // make p positive
    mov p,ebx
  }
Check_a:
  __asm {

    mov v3,ebx             // v3=p
    mov ecx,1              // ecx is inverse
    mov eax,a              // ȉ eax=a
    or  eax,eax
    jge Main_loop
    mov ecx,-1
    neg eax
  }
Main_loop:
  __asm {

    cmp v3,0               // v3=0 ȂI
    jne divide
    cmp eax,1
    jne set_zero
    or  ecx,ecx
    jge RET1
    add ecx,p
    jmp RET1
  }
divide:
  __asm {

    xor edx,edx
    div v3                // a/v3
    mov t3,edx            // ]Z|u
    mul v1
    sub ecx,eax           // ecx -= q*v1
    xchg ecx,v1
    mov eax,t3
    xchg eax,v3
    jmp Main_loop
  }
set_zero:
   __asm xor ecx,ecx

RET1:
#ifdef __BORLANDC__
  __asm mov eax,ecx
  return _EAX ;
#else
  __asm mov a,ecx
  return a ;
#endif
}
