//
//	Copyright (C) by S.Tomabechi 1993,1997
//	All rights reserved.
//
//	product of real numbers
//
//	̐
//
//	vZʂ́A_ȉ̌傫̌Ŋۂ߂D
//
//	܂܂ŁA̐ς𗘗p̊֐ŕĂA̐ς
//	p邱ƂɂD̕AƂĂ̐ς̌ʂɂ鏬_ʒu
//	炷삪KvɂȂ邪Ał͂ȂD傫Ȑ
//	ɂZɂȂĂ邱Ƃɂʂ̂ق傫悤D
//
//	1997/06/18
//	  0.9^n -> 0  as n-> ƂȂȂCD
//
#ifdef __BORLANDC__
#pragma inline
#endif

#include "Fint.hpp"
#include <stdlib.h>
#include "Error.hpp"

Fint& Fint::isMulF(const Mint& a,const Mint& b)
{
#ifdef _MEMMAN_DEBUG
a.check(__FILE__,__LINE__) ;
b.check(__FILE__,__LINE__) ;
#endif

  int afDigit ;
  int bfDigit ;
  bool asame ;
  bool bsame ;

  __asm {
	mov  esi,a
	mov  edi,b
#ifdef __BORLANDC__
	mov  eax,[esi.fDigit]
	mov  ebx,[esi.nDigit]
#else
	mov  eax,dword ptr [esi+FDIGIT]
	mov  ebx,dword ptr [esi+NDIGIT]
#endif

#ifdef __BORLANDC__
	mov  ecx,[edi.fDigit]
	add  ebx,[edi.nDigit]
#else
	mov  ecx,dword ptr [edi+FDIGIT]
	add  ebx,dword ptr [edi+NDIGIT]
#endif

	cmp  eax,ecx			 // a ̏_ʒu > b ̏_ʒu ?
	jae  DO_NOT_EXCHANGE
	xchg esi,b				 // a  b 
	xchg edi,a
	xchg eax,ecx
  }
DO_NOT_EXCHANGE:
  __asm {
	mov  afDigit,eax		  // _ʒuZ[u
	cmp  ebx,ecx
	ja	 SET_AS_INTEGER

	mov  esi,this			  // ʂ͐xȉ̐ Ȃ킿 
#ifdef __BORLANDC__
	mov  dword ptr [esi.nDigit],0
	mov  [esi.fDigit],eax
	mov  byte ptr [esi.nDim+3],1
#else
	mov  dword ptr [esi+NDIGIT],0
	mov  dword ptr [esi+FDIGIT],eax
	mov  byte ptr [esi+SIGN],1
#endif
	jmp  RET1
  }

SET_AS_INTEGER:
  __asm {
	mov  bfDigit,ecx		  // _ʒuZ[u

							  // lɂ
#ifdef __BORLANDC__
	mov  dword ptr [esi.fDigit],0
	mov  dword ptr [edi.fDigit],0
#else
	mov  dword ptr [esi+FDIGIT],0
	mov  dword ptr [edi+FDIGIT],0
#endif

	cmp  esi,this			  // this=&a ?
	sete asame

	cmp  edi,this			  // this=&b
	sete bsame
  }

						 // ƂĐςvZ
PRODUCT:
  ((Mint*)this)->isMul((Mint&)a,(Mint&)b) ;  // product as integer


POST_PRODUCT: ;
  __asm {
	mov   esi,a
	cmp   asame,0
	jne   Restore_b
									// this!=&a
#ifdef __BORLANDC__ 				// ɖ߂
	mov   eax,afDigit
	mov   [esi.fDigit],eax
#else
	mov   eax,afDigit
	mov   dword ptr [esi+FDIGIT],eax
#endif
  }
Restore_b:
  __asm {

	cmp   bsame,0
	jne   Set_this

	mov   edi,b
	cmp   edi,esi
	je	  Set_this
								  // &a!=&b
								  // ɖ߂
	mov   ecx,bfDigit
#ifdef __BORLANDC__
	mov   dword ptr [edi.fDigit],ecx
#else
	mov   dword ptr [edi+FDIGIT],ecx
#endif
  }

Set_this:
  __asm {
	mov   esi,this
	mov   eax,afDigit
  }
  __asm {
#ifdef __BORLANDC__
	mov   [esi.fDigit],eax
	mov   edi,[esi]
	mov   ecx,[esi.nDigit]
#else
	mov   dword ptr [esi+FDIGIT],eax
	mov   edi,dword ptr [esi]
	mov   ecx,dword ptr [esi+NDIGIT]
#endif

	mov   eax,bfDigit

	sub   ecx,eax
	jbe   this_is_Zero			  // L < _ʒu
#ifdef __BORLANDC__
	sub   [esi.nDigit],eax	  // 炷
#else
	sub   dword ptr [esi+NDIGIT],eax
#endif

	or	  eax,eax					   // b ̏ꍇ ?
	jz	  RET1						   // ľܓʒuȂ
	lea   ebx,[edi+eax*NBYTE]		  // bfDigit Vtg
	xor   edx,edx
//	  mov	eax,[ebx-NBYTE]  //  ۂ߂ȂƂ͂ s
//	  add	eax,0x80000000				 //  폜
  }
AddMove:							   // ۂ߂ȂAsKvȌ̂Ă
  __asm {							   // ̃[vł̓L[tO
									   // ω鉉Zq͎gpȂ
	mov   eax,[edx*NBYTE+ebx]
	adc   eax,0
	mov   [edx*NBYTE+edi],eax
	lea   edx,[edx+1]
	dec   ecx
	jnz   AddMove
	jnc   RET1						   // オȂ

#ifdef __BORLANDC__
	inc   dword ptr [esi.nDigit]	   // オ肠	 1 ₷
#else
	inc   dword ptr [esi+NDIGIT]
#endif
	mov   dword ptr [edx*NBYTE+edi],1
	jmp   RET1
  }

this_is_Zero:				  // l 0 ɂ
  __asm {
#ifdef __BORLANDC__
	mov byte ptr [esi.nDim+3],1
	mov dword ptr [esi.nDigit],0
#else
	mov byte ptr [esi+SIGN],1
	mov dword ptr [esi+NDIGIT],0
#endif
  }


RET1:
#ifdef _MEMMAN_DEBUG
check(__FILE__,__LINE__) ;
//_MemMan.check(__FILE__,__LINE__) ;
#endif
  return *this ;
}

