//
//	Copyright (C) by S.Tomabechi 1995
//	All rights reserved.
//
//	񕪐ɂA𐳂ɂ
//
#include "Ratlong.hpp"
RatLong RatLong::_Rtemp ;

RatLong& RatLong::normalize()
{
  long temp=gcd(Den,Num) ; ;

  if( temp!=1 ) {
	Den/=temp ;
	Num/=temp ;
  }
  if( Den<0 ) {
	Den=-Den ;
	Num=-Num ;
  }
  return *this ;
}

int compare(long a,long b)
{
  a -= b ;
  if( a<0 ) return isLess ;
  else if( a==0 ) return isEqual ;
  else return isGreater ;
}


RatLong RatLong::operator+(RatLong& a)
{
  RatLong q ;
  q.Den=Den*a.Den ;
  q.Num=Num*a.Den+Den*a.Num ;
  return q.normalize() ;
}

::ostream& operator<<(::ostream& os,RatLong& a)
{
  os << a.Num  ;
  if( a.Den!=1 ) os << '/' << a.Den ;
  return os ;
}
