//
//  Copyright (C) by S.Tomabechi 1993,1997
//  All rights reserved.
//
//  shift as 2^32-adic number
//
//  2^32 iƂČ炷.
//

#include "Mint.hpp"
#ifdef __BORLANDC__
#pragma inline
#endif

Mint& Mint::isShift32(const Mint& a,const long n)
{
#ifdef _MEMMAN_DEBUG
a.check(__FILE__,__LINE__) ;
#endif
  if( n>0 ){

    if( n+a.nDigit>ndim() ) {                // ]T邩
      if( this==&a ) reallocate(n+nDigit) ;  // g
      else allocate(n+a.nDigit) ;            // this!=&a
    }
    __asm {

      mov esi,a
      mov edi,this
      mov edx,n                              // edx <- Vtg fixed
#ifdef __BORLANDC__
      mov al,[esi.nDim+3]
      mov [edi.nDim+3],al

      mov ecx,[esi.nDigit]   // ecx; Ƃ̌. ƂŃJE^Ɏgp
      mov eax,ecx
      add eax,edx                      // Vtǧ
      mov [edi.nDigit],eax

      mov eax,[esi.fDigit]
      or  eax,eax                      //  ?
      jz  OK
      add eax,edx                      // _ʒuړ
#else
      mov al,[esi+SIGN]
      mov [edi+SIGN],al

      mov ecx,[esi+NDIGIT]
      mov eax,ecx
      add eax,edx
      mov [edi+NDIGIT],eax

      mov eax,[esi+FDIGIT]
      or  eax,eax
      jz  OK
      add eax,edx
#endif
    }
OK:
    __asm {
#ifdef __BORLANDC__
      mov [edi.fDigit],eax
      mov esi,[esi]
      mov edi,[edi]
#else
      mov [edi+FDIGIT],eax
      mov esi,[esi]
      mov edi,[edi]
#endif

      lea edi,[edi+edx*NBYTE]          // Vtg镪ItZbg

      or  ecx,ecx                       // L=0 i.e.  ?
      jnz MOVE
      mov edi,this                      // ƂƗ낾
#ifdef __BORLANDC__                     // ʂ́AƂƈقȂ
      mov dword ptr [edi.nDigit],0      // _ʒu n Vtgꂽ
#else
      mov dword ptr [edi+NDIGIT],0
#endif
      jmp RET0

    }
MOVE:
    __asm {
      mov eax,[ecx*NBYTE+esi-NBYTE]
      mov [ecx*NBYTE+edi-NBYTE],eax
      dec ecx
      jnz MOVE

      mov ecx,edx
      xor eax,eax
    }
CLEAR:                                 // ̌ 0 𑗂荞
    __asm {
      mov [edi-NBYTE],eax
      lea edi,[edi-NBYTE]
      dec ecx
      jnz CLEAR
    }
  }
  else if( n<0 ) {                     // ؂̂Ăꍇ

    if( this!=&a && ndim()<a.nDigit ) allocate(a.nDigit) ;

    __asm {

      mov eax,n                        // Vtg
      neg eax

      mov esi,a
      mov edi,this
#ifdef __BORLANDC__
      mov bl,[esi.nDim+3]
      mov [edi.nDim+3],bl

      mov ecx,[esi.nDigit]    // cx=nDigit 
#else
      mov bl,[esi+SIGN]
      mov [edi+SIGN],bl

      mov ecx,[esi+NDIGIT]    // cx=nDigit 
#endif
      sub ecx,eax                       // cx=cx-a ړ
      jle SET_ZERO        // cx<=a łAVtǧ,L<=0 ƂȂ

#ifdef __BORLANDC__
      mov edi,[edi]
      mov esi,[esi]
#else
      mov edi,[edi]
      mov esi,[esi]
#endif
      lea esi,[esi+eax*4]
      xor ebx,ebx
    }
MOVE2:
    __asm {                    // move digits
      mov eax,dword ptr [ebx*NBYTE+esi]
      mov dword ptr [ebx*NBYTE+edi],eax
      inc ebx
      dec ecx
      jnz MOVE2

      mov esi,a
      mov edi,this
      mov eax,n               // 
#ifdef __BORLANDC__
      mov ebx,[esi.nDigit]
      add ebx,eax
      mov [edi.nDigit],ebx
#else
      mov ebx,[esi+NDIGIT]
      add ebx,eax
      mov [edi+NDIGIT],ebx
#endif
    }
//NonZero:
     __asm {
#ifdef __BORLANDC__
      mov ebx,[esi.fDigit]
      add ebx,eax
      js  INTEGER
      mov [edi.fDigit],ebx
#else
      mov ebx,[esi+FDIGIT]
      add ebx,eax
      js  INTEGER
      mov [edi+FDIGIT],ebx
#endif
      jmp RET0
  }

INTEGER:
    __asm {
#ifdef __BORLANDC__
      mov dword ptr [edi.fDigit],0
#else
      mov dword ptr [esi+FDIGIT],0
#endif
      jmp RET0
    }

SET_ZERO:
    __asm {
#ifdef __BORLANDC__
      mov dword ptr [edi.nDigit],0
      sub [edi.fDigit],eax
      jns SET_SIGN
      mov dword ptr [edi.fDigit],0
    }
SET_SIGN:
  __asm {
      mov byte ptr [edi.nDim+3],1      // ̗
#else
      mov dword ptr [edi+NDIGIT],0
      sub [edi+FDIGIT],eax
      jns SET_SIGN
      mov dword ptr [edi+FDIGIT],0
    }

SET_SIGN:
    __asm {
      mov byte ptr [edi+SIGN],1   // ̗
#endif
    }

  }
  else {
    if( this!=&a ) *this=a ; // VtgȂRs[͂
  }

RET0: ;
#ifdef _MEMMAN_DEBUG
check(__FILE__,__LINE__) ;
#endif
  return *this ;

}

