//
//  Copyright (C) by S.Tomabechi 1998
//  All rights reserved.
//
//  modular addition,subtraction
//
// @ZA@Z
//

// calculate a+b mod p
#ifdef __BORLANDC__
#pragma inline
#endif
unsigned long isAdd(const unsigned long a,const unsigned long b,const unsigned long p)
{
  __asm {
    mov eax,a
    xor edx,edx
    add eax,b
    adc edx,edx              // a+b is treated as 64bit integer
    div p
#ifdef __BORLANDC__
    mov eax,edx
  }
  return _EAX ;
#else
    mov p,edx
  }
  return p ;
#endif
}

// calculate a-b mod p
unsigned long isSub(const unsigned long a,const unsigned long b,const unsigned long p)
{
  __asm {
    xor edx,edx
    mov eax,b
    div p
    mov eax,a
    sub eax,edx
    jnc SET_RESULT
    add eax,p
  }
SET_RESULT:

  __asm {
    xor edx,edx
    div p
#ifdef __BORLANDC__
    mov eax,edx
  }
  return _EAX ;
#else
    mov p,edx
  }
  return p ;
#endif

}

