//
//  Copyright (C) by S.Tomabechi 1994,1995
//  All rights reserved.
//
//  conversion    long double <- Fint
//
// ^ϊ֐  long double <- Fint
// w傫Ȃ鐔ɂĂ͕ϊłȂ̂,
// w̑Óɂă`FbNȂ̂ŁCʂȂ邱Ƃ.
//
#ifndef __cplusplus
#error Must use C++ for the type Fint
#endif

#define _ONLY_MINTDECL_
#define _ONLY_FINTDECL_
#include "Fint.hpp"
#include "LDbl.hpp"
#include "Dbl.hpp"
#include "IntFuncs.hpp"

#ifdef __BORLANDC__
Fint::operator long double() const
{
  LDbl d(0) ;

  unsigned long n,p ;
  long j,k,l ;
  k=nDigit-1 ;
  if( k<0 ) return d ;  // L<=0

  l=ilog2(digit[k])+1 ;

  n = (digit[k])<<(32-l) ;        // LZbg
                                  // l=32 ̂Ƃ p=0 Ƃ悤ɏC
                                  // n>>32  0 ɂȂƎvĂ
                                  // n>>32 ͉ωAn gł邽
                                  // l<32 Ƃݒ肵Ȃ bug ɂȂ
  if( k>0 && l<32 ) p = digit[k-1]>>l ;
  else p=0 ;
  n+=p ;
  d.SetHigh(n) ;

  if( k>0 ) n=(digit[k-1])<<(32-l) ;
  else n=0 ;
  if( k>1 && l<32 ) p=(digit[k-2])>>l ;
  else p=0 ;
  n+=p ;
  d.SetLow(n) ;

  d.SetSign(sign(*this)) ;  // Zbg
  j=(k-fDigit)*NBITS ;
  j+=(l-1) ;
  d.SetExp(j) ;            // wZbg

  return (long double)d ;

}
#endif


Fint::operator double() const
{
  Dbl d(0) ;

  unsigned long n,p ;
  long j,k,l ;

  k=nDigit-1 ;
  if( k<0 ) return d ;

  l=ilog2(digit[k]) ;

  if( k>0 ) {
    n = (digit[k])<<(32-l) ;
    if( n==1 ) n=0 ;
  }
  else {
    d=Dbl(1.0) ;
    goto SetSign ;
  }
  if( k>0 && l<32 ) p = digit[k-1]>>l ;
  else p=0 ;
  n+=p ;
  d.SetHigh(n) ;

  if( k>0 ) n=(digit[k-1])<<(32-l) ;
  else n=0 ;
  if( k>1 && l<32 ) p=(digit[k-2])>>l ;
  else p=0 ;
  n+=p ;
  d.SetLow(n) ;

SetSign:
  d.SetSign(sign(*this)) ;  // Zbg
  j=(k-fDigit)*NBITS ;
  j+=l ;
  d.SetExp(j) ;            // wZbg

  return (double)d ;

}

