//
//  Copyright (C) by S.Tomabechi 1997
//  All rights reserved.
//
//  񐔂̘a
// \sigma(n) = sum of divisors of n
//             1 and n included
//
#ifdef __BORLANDC__
# include <algorith>
#else
# include <algorithm>
#endif
# include <vector>

#include "Mint.hpp"

using namespace std ;
int divisor(unsigned long N,vector< unsigned long >& d) ;

unsigned long sigma(const unsigned long N)
{
  int ndiv ;
  int j ;
  vector< unsigned long > div(10) ;
  unsigned long s,t ;
  ndiv=divisor(N,div) ;        // decomposition
  s=1 ;
  if( ndiv==-1 ) return N+1 ;  // N is prime
    for( j=0 ; j<ndiv ; ) {
    t=div[j]+1 ;
    for( j++ ; j<ndiv ; j++) {
      if( div[j-1]!=div[j] ) break ; // different divisor ?
      t*=div[j] ;
      ++t ;
    }
    s*=t ;
  }
  return s ;
}

