//
//  Copyright (C) by S.Tomabechi 1994
//  All rights reserved.
//
//  rbg̃NX
//  gƂẮAW 2 ̑̂ɌWxNgz肵Ă.
//  邢, Gp(2^n)̃NX.
//
#ifndef __LBIT_HPP
#define __LBIT_HPP

#include <iostream.h>
#include "TBit.hpp"

#define TRUE 1
#define FALSE 0

class LBit : public TBit
{
public:
  static long Size ;
  LBit(const long _size=LBit::Size) ;
  LBit(const LBit& B) ;
  ~LBit() { delete [] bit ; }
  LBit& operator=(const LBit& B) ;           // 
  LBit  operator^(const LBit& B) ;           // rI_a
  LBit& operator^=(const LBit& b) ;
  LBit& operator&=(const LBit& B) ;          // _
  LBit& operator|=(const LBit& B) ;          // _a

  friend ostream& operator<<(ostream&,const LBit&) ;
  friend void read(istream&,LBit&) ;
  friend void xchg(LBit& a,LBit& b) ;  // 
} ;

void xchg(LBit& a,LBit& b) ;
extern LBit _Btemp ;

inline void write(ostream& os,const LBit& B)
{
  write(os,(TBit&)B) ;
}

inline LBit& LBit::operator^=(const LBit& b)
{
  return (LBit&)((TBit&)*this).operator^=((TBit&)b) ;
}

inline LBit& LBit::operator&=(const LBit& b)
{
  return (LBit&)((TBit&)*this).operator&=((TBit&)b) ;
}

inline LBit& LBit::operator|=(const LBit& b)
{
  return (LBit&)((TBit&)*this).operator|=((TBit&)b) ;
}

inline void xchg(LBit& a,LBit& b)
{
  xchg((TBit&)a,(TBit&)b) ;
}

inline ostream& operator<<(ostream& os,const LBit& B)
{
  return os << (TBit&)B ;
}

#endif

