//
//	Copyright (C) by S.Tomabechi 1993
//	Allrights reserved.
//
//	Vector class
//

#ifndef _VECFUNC_HPP_
#define _VECFUNC_HPP_
#include <vector>
//#include <algorithm>
#include <iostream.h>

using namespace std ;



// v.size >= size() Ɖ肷
template<class T>
vector<T>& operator+=(vector<T>& u,const vector<T>& v)
{
  int j=size()-1 ;
  for( ; j>=0 ; j-- ) u[j]+=v[j] ;
  return u ;

}

// v.size >= size() Ɖ肷
template<class T>
vector<T>& operator-=(vector<T>& u,vector<T>& v)
{
  int j=size()-1 ;
  for( ; j>=0 ; j-- ) u[j]-=v[j] ;
  return u ;
}

template<class T,class S>
vector<T> operator+(const vector<T>& u,const vector<S>& v)
{
  vector<T> sum=u ;
  return u+=v ;
}


template<class T,class S>
vector<T> operator-(vector<T>& u,vector<S>& v)
{
  vector<T> sub=u ;
  return u-=v ;
}

// a is scalar
template<class T>
vector<T> operator*(const T& a,const vector<T>& v)
{
  vector<T> u=v ;
  for( int j=v.size()-1 ; j>=0 ; j-- ) u[j]*=a ;
  return u ;
}

template<class T,class S>
vector<T>& operator*=(vector<T>& v,const S& a)
{
  for( j=v.size() ; j>=0 ; j-- ) v[j]*=a ;

  return v ;
}

template<class T>
inline T operator*(const vector<T>& v)
{
  return inner_product(begin(),end(),vbegin(),T(0)) ;
}

template<class T>
ostream& operator<<(ostream& os,vector<T>& a)
{
  for( int j=0 ; j<a.size() ; j++ ) os << a[j] << " "	 ;
  return os ;
} ;



#endif
