//
//  Copyright (C) by S.Tomabechi 1993,1994,1995
//  All rights reserved.
//
//  return integer part of real number
//
//  ̐Ԃ.
//
#ifdef __BORLANDC__
#pragma inline
#endif

#ifndef __cplusplus
#error Must use C++ for the type Fint
#endif


#define _ONLY_MINTDECL_
#define _ONLY_FINTDECL_
#include "Fint.hpp"

Mint Int(const Fint& f)
{

//  int iDigit(f.nDigit-f.fDigit) ;
  int iDigit ;
#ifndef __BORLANDC__
  Mint* tptr=&Mint::_Mtemp ;
#endif

  __asm {
    mov esi,f
#ifdef __BORLANDC__
    mov  ecx,[esi.nDigit]
    mov  edx,[esi.fDigit]
#else
    mov  ecx,[esi+NDIGIT]
    mov  edx,[esi+FDIGIT]

#endif
    sub ecx,edx
    jle ZERO                           // integer part=0 ?
    mov iDigit,ecx

#ifdef __BORLANDC__
    mov ebx,dword ptr [@Mint@_Mtemp.nDim]
#else
    mov edi,tptr
    mov ebx,[edi+NDIM]
#endif
    and ebx,_DIGITS_
    cmp ebx,ecx
    jb  ALLOC
    jmp EXEC
  }
ZERO:
  return Mint::_Mtemp=0 ;
ALLOC:
  Mint::_Mtemp.allocate(iDigit) ;

//  if( iDigit<=0 ) return Mint::_Mtemp=0 ;
//  if( Mint::_Mtemp.nDim<iDigit ) Mint::_Mtemp.allocate(iDigit) ;

  __asm {
    mov   esi,f
#ifdef __BORLANDC__
    mov  edx,[esi.fDigit]
#else
    mov  edi,tptr
    mov  edx,[esi+FDIGIT]
#endif
  }
EXEC:
  __asm {
#ifdef __BORLANDC__
    mov  al,[esi.nDim+3]
    mov  esi,[esi]
#else
    mov  al,[esi+SIGN]
    mov  esi,[esi]
#endif
    mov  ecx,iDigit
  }
//Move:
  __asm {
#ifdef __BORLANDC__
    mov  [@Mint@_Mtemp.nDim+3],al    // set signature
    mov  dword ptr [@Mint@_Mtemp.nDigit],ecx            // # digits
    mov  edi,dword ptr [@Mint@_Mtemp]
#else
    mov  [edi+SIGN],al
    mov  [edi+NDIGIT],ecx
    mov  edi,[edi]
#endif
    lea  esi,[esi+edx*NBYTE]
    rep  movsd
  }

#ifdef _MEMMAN
Mint::_Mtemp.check(__FILE__,__LINE__) ;
#endif
  return Mint::_Mtemp ;
}

