//
//  Copyright (C) by S.Tomabechi 1995
//  All rights reserved.
//
//  compute x^n mod p
//
//  mod p ł̙pvZ
//
#ifdef __BORLANDC__
#pragma inline
#endif

long power(const long x,const unsigned long n,const long p)
{
  long y=1 ;

  __asm {
    mov   esi,n    // esi <- n fixed
    bsr   edi,esi  // bit lenght of n
    jz    RET1      // exit if n=0
    mov   ecx,p
//    cmp   ecx,0    // p>0 ?
    or    ecx,ecx
    jge   POSITIVE
    neg   ecx      // p <- |p|
  }
POSITIVE:
  __asm {
    mov  eax,x     // x ŏ]ɕϊ
    cdq
    idiv ecx
    mov  ebx,edx   // ebx <- x ȌŒ
//    cmp  ebx,0
    or   ebx,ebx
    jge  LOOP
    add  ebx,ecx
  }
LOOP:
  __asm {
    test esi,1     // n ͊ ?
    jz   SQUARE    // 
    mov  eax,y
    mul  ebx       // y*x
    div  ecx       // %p
    mov  y,edx     // y <- (y*x)%p
  }
SQUARE:
  __asm {
    dec edi
    js  RET1
    shr esi,1      // n /= 2
    mov eax,ebx    // eax <- x
    mul ebx        // x*x
    div ecx        // %p
    mov ebx,edx    // x <- (x*x)%p
    jmp LOOP
  }
RET1:
  return y ;

}
