//
//  Copyright (C) by S.Tomabechi 1994,1995,2000
//  All rights reserved.
//
//  return the smallest divisor
//
//   return valuse : the smallest divisor if exists
//                   0   when n has big prime divisor or maybe
//                   1   when n is prime
//
#ifdef __BORLANDC__
#pragma inline
#endif

#include "Mint.hpp"
extern const unsigned char _t_[] ;
extern const unsigned char _small_prime_[] ;

//Mint isqrt(Mint& n) ;

#if 0
unsigned long prmdiv(const Mint& n,const unsigned long MAX_DIVISOR)
{
                                              // ꌅ̐
  if( n.ndigit()<2 ) return prmdiv((unsigned long)n) ;

  if( !(((unsigned long)n)&1) ) return 2 ;    // n mod 2 = 0 ?
  else if( n%3==0 ) return 3 ;                // n mod 3 = 0 ?
  else if( n%5==0 ) return 5 ;                // n mod 5 = 0 ?
  else if( n%7==0 ) return 7 ;                // n mod 7 = 0 ?
  else if( n%11==0 ) return 11 ;              // n mod 11 = 0 ?

  unsigned long d=11 ;
  int k=47 ;

  Mint sqn=isqrt(n) ;
  Mint w ;

  for( ; d<MAX_DIVISOR ;) {
    if( (++k)==48 ) k=0 ;
    d+=_t_[k] ;
    Mint::_Mtemp.isDivUL(n,d) ;
    if( Mint::_Mtemp<sqn ) return 1UL ;       // n ͑f
    if( Mint::_res==0 ) return d ;            // n ͍
  }

  return 0UL ;              // ȑf͌Ȃ
                            // f͕Ȃ
}

#endif

unsigned long prmdiv(const Mint& n,const unsigned long MAX_DIVISOR)
{

  if( n.ndigit()<2 ) return prmdiv((unsigned long)n) ;   // n < 2^32
  else if( n.ndigit()==2 ) return prmdiv2(n.digit[1],n.digit[0],MAX_DIVISOR) ;  // n < 2^64

  unsigned long ndigit ;
  unsigned long divisor ;

  __asm {
    xor esi,esi

    mov edi,n
#ifdef __BORLANDC__
    mov eax,[edi.nDigit]
    mov edi,[edi]
#else
    mov eax,[edi+NDIGIT]
    mov edi,[edi]
#endif
    dec eax
    mov ndigit,eax
  }
SMALL:                                  // divide by 2,3,5,7,11
  __asm {
    movzx ebx,byte ptr [_small_prime_+esi]

    xor edx,edx
    mov ecx,ndigit
  }
LOOP_SMALL:
  __asm {
    mov eax,[edi+NBYTE*ecx]
    div ebx
    dec ecx
    jns LOOP_SMALL

    or  edx,edx
    jz  FOUND                           // divisible by small prime

    inc esi
    cmp si,5
    jb  SMALL

//  mov edi,MAX_DIVISOR
    mov si,47
    jmp NEXT
  }

TRY_DIV:
  __asm {
    cmp ebx,MAX_DIVISOR
    ja  RET_9

    mov ecx,ndigit
    xor edx,edx
  }
LOOP_DIV:
  __asm {                              // divide by numbers > 11
    mov eax,[edi+NBYTE*ecx]
    div ebx
    dec ecx
    jns LOOP_DIV

    or  edx,edx
    jz  FOUND
  }
NEXT:
  __asm {
    inc esi
    cmp si,48
    jne NEXT1
    xor esi,esi
  }

NEXT1:
  __asm {
    movzx ecx,byte ptr [_t_+esi]
    add   ebx,ecx
    jmp   TRY_DIV
  }

FOUND:
  __asm {
    mov divisor,ebx
    jmp RET1
  }
#if 0
PRIME:
  __asm {
    mov divisor,1
    jmp RET1
  }
#endif
RET_9:
  __asm {
    mov divisor,0
    jmp RET1
  }
RET1:
  return divisor ;

}

