//
//  Copyright (C) by S.Tomabechi 1994,1997
//  All rights reserved.
//
//  prime decomposition by rho-method
//
#include "Mint.hpp"

//
// N    (I) ׂ
// itry (I) [v̉ ʏ 100`1000 炢ł悢D
// c    (I) gp񎟑 x^2+c ̒萔. 1,-1,3 Ƃl悢
//           c=0 w肵Ă͂ȂȂD
// ߂l   f Ȃꍇ́A1 Ԃ
//

extern bool display_rho=false ;
Mint rho(const Mint& N,int itry,int c)
{
Initialize:
  Mint x(2),y(2),x1(2) ;
  int j,k(1),l(1),iter(0) ;
  unsigned long e ;
  Mint P(1),g,w ;

  if( powerdetect(N,g,e) ) return g ;
  g=SquareTest(N) ;
  if( g>0 ) return g ;

  if( display_rho ) {
    cout << endl << "rho-method x^2" ;
    if( c>0 ) cout << "+" << c ;
    else cout << c ;
    cout << endl << N << flush ;
  }

#if 0
  for(;;) {
//    ((x*=x)+=c)&=N ;              // x=x*x+c mod N
    (y.isSquare(x)+=c)^=N ;
    (P*=w.isSub(x1,y))^=N  ;      // P=x1-1 mod N
    if( ++iter==20 ) {
      g.isGCD(P,N) ;
      if( g>1 ) break ;
      else iter=0 ;
      if( --itry<=0 ) return g=1 ;
    }

    if( --k!=0 ) continue ;
    g.isGCD(P,N) ;                // g=gcd(P,N) ;
    if( g>1 ) break ;             // found
    else {
      x1=y ;
      k=l ;
      l<<=1 ;
      for( j=k ; j>0 ; j-- ) {    // iteration
//        ((x*=x)+=c)&=N ;
//        (x.isSquare(x)+=c)^=N ;
        (x.isSquare(y)+=c)^=N ;
        Swap(x,y) ;

      }
//      y=x ;                       // ǂ܂łoĂ
      x=y ;
      iter=0 ;
    }

  }
#else
  for(;;) {
//    ((x*=x)+=c)&=N ;              // x=x*x+c mod N
    (x.isSquare(x)+=c)^=N ;
    (P*=w.isSub(x1,x))^=N  ;      // P=x1-1 mod N
    if( ++iter==20 ) {
      g.isGCD(P,N) ;
      if( g>1 ) break ;
      else { y=x ; iter=0 ; }
      if( --itry<=0 ) return g=1 ;
    }

    if( --k!=0 ) continue ;
    g.isGCD(P,N) ;                // g=gcd(P,N) ;
    if( g>1 ) break ;             // found
    else {
      x1=x ;
      k=l ;
      l<<=1 ;
      for( j=k ; j>0 ; j-- ) {    // iteration
//        ((x*=x)+=c)&=N ;
//        (x.isSquare(x)+=c)^=N ;
        (y.isSquare(x)+=c)^=N ;
        Swap(x,y) ;

      }
      y=x ;                       // ǂ܂łoĂ
      iter=0 ;
    }

  }
#endif

BackTrack:
  do {
//    ((y*=y)+=c)&=N ;
#if 0
    (y.isSquare(y)+=c)^=N ;
    g.isGCD(w.isSub(x1,y),N) ;
#else
    (x.isSquare(y)+=c)^=N ;
    g.isGCD(w.isSub(x1,x),N) ;
    Swap(x,y) ;
#endif
  } while( g==1 ) ;

//cout << endl << "in PolRho "  << g ;
  if( g<N ) return g ;
  else return g=1 ;
}