//
//  Copyright (C) by S.Tomabechi 1994,1995,1997
//  All rights reserved.
//
//  shift to left by n-bits  ( vaild for even n>32 )
//
//
//   n rbgVtg (2^n )
//
//  n : VtgrbgA32ȏł悢
//
#ifdef __BORLANDC__
#pragma inline
#endif
#define _ONLY_MINTDECL_
#include "Mint.hpp"
#include <iostream.h>
#include <iomanip.h>

Mint& Mint::isShiftl(const Mint& a,const long n)
{
#ifdef _MEMMAN_DEBUG
a.check(__FILE__,__LINE__) ;
#endif
  int s,anDigit ;
  unsigned long idi ;

  if( n==0 ) return *this=a ; // do nothing

  s=(n>>5)+1 ;
  if( ndim()<(s+a.nDigit) ) {     // enough memory ?
    if( this==&a ) reallocate(s+a.nDigit) ;
    else allocate(s+a.nDigit) ;
  }
  if( a.isZero() ) return *this=a ;

  __asm {
    mov   ecx,n

    mov   esi,a
    mov   edi,this
#ifdef __BORLANDC__
    mov   edx,[esi.nDigit]
    mov   anDigit,edx
    dec   edx
    mov   ebx,[esi]
    bsr   eax,[edx*NBYTE+ebx]
    shl   edx,5
    add   edx,eax              // bit lenght now
    add   edx,ecx              // bit length post shifting

    shr   edx,5
    inc   edx                  // number of digits post shifting
    mov   [edi.nDigit],edx
    mov   eax,[esi.fDigit]
    mov   [edi.fDigit],eax  // DO NOT CHNANGE fractional point position
    mov   al,[esi.nDim+3]   // copy signature
    mov   [edi.nDim+3],al

    mov   esi,[esi]
    mov   edi,[edi]
#else
    mov   edx,[esi+NDIGIT]
    mov   anDigit,edx
    dec   edx
    mov   ebx,[esi]
    bsr   eax,[edx*NBYTE+ebx]
    shl   edx,5
    add   edx,eax
    add   edx,ecx

    shr   edx,5
    inc   edx
    mov   [edi+NDIGIT],edx
    mov   eax,[esi+FDIGIT]
    mov   [edi+FDIGIT],eax
    mov   al,[esi+SIGN]
    mov   [edi+SIGN],al

    mov   esi,[esi]
    mov   edi,[edi]
#endif

    mov   idi,edi
  }

  __asm {
    mov   ebx,anDigit
    lea   esi,[esi+ebx*NBYTE-NBYTE]    // position of most significant digit
                                       // a̐擪̃AhX
    lea   edi,[edi+edx*NBYTE-NBYTE]    // position of most significant digit post shifting

    and   ecx,0000001fh         // n%32
    xor   edx,edx
    mov   eax,[esi]             // ֑荞ރrbg
    shld  edx,eax,cl            // shift left by cl-bit
                                // cl rbgփVtg edx ɑ荞
    jz    LOOP_SHIFT
    mov   [edi],edx             // save bits oveflowed
                                // E炠ӂĂrbgZ|u
    lea   edi,[edi-NBYTE]
  }
LOOP_SHIFT:
  __asm {
    lea   esi,[esi-NBYTE]
    dec   ebx
    jz    EXIT
    mov   edx,eax
    mov   eax,[esi]
    shld  edx,eax,cl           // propagete overflow
                               // ̌̂ӂ`
    mov   [edi],edx
    lea   edi,[edi-NBYTE]
    jmp   LOOP_SHIFT
  }
EXIT:
  __asm {
    shl   eax,cl
    mov   [edi],eax

    mov   ecx,n
    shr   ecx,5
    jecxz RET1
    mov   edi,idi   // ʂ̌̈ʒu
    xor   eax,eax
  }
//CLEAR:
  __asm {
    rep stosd
  }
RET1:
#ifdef _MEMMAN_DEBUG
check(__FILE__,__LINE__) ;
#endif
  return *this ;
}

