//	D=S*T	S is square
#include "Mint.hpp"
#include "IntFuncs.hpp"

void SquarePart(Mint& D,Mint& S,Mint& T,unsigned long MaxPrime)
{
	Mint F ;
	Mint s ;
	unsigned long nP(8192) ;
	unsigned long* index ;
	unsigned long* primes ;
	unsigned long B ;
	unsigned long j ;
	unsigned long k ;

//unsigned long mm=0 ;
	index=new unsigned long[nP] ;
	primes=new unsigned long[nP] ;
	T=F=D ;					  // decompose D s.t. D=S^2*T T dose not have square divisor
	if( F<0 ) ~F ;
	S=1 ;

	for( B=1 ; ;) {
		memset(index,0x00,nP*sizeof(unsigned long)) ;
		for( j=0 ; j<nP ; j++ ) {
			B=nextprm(B) ;
			primes[j]=B ;
			if( B>MaxPrime ) { j++ ; break ; }
		}
		k=j ;
		PrimeDecomp(k,primes,index,F) ;
		for( j=0 ; j<k ; j++ ) {
			// J荞
			if( index[j]!=0 ) {
				S*=power(primes[j],index[j]>>1) ;
//				(S*=power(Mint(primes[j]),Mint(index[j]>>1),N))%=N	;
				T/=power(Mint(primes[j]),(index[j]>>1)<<1) ;
			}
		}
		if( F!=1 ) {
			s=isqrt(F) ;			 // c͂ЂƂƕȂ
			if( (F%s)%s==0	) {	 // ȂAȂȂł܂sꍇ
				S*=s ;
				F/=(s*s) ;
				T/=(s*s) ;
			}
			if( F==1 ) break ;
		}
		else break ;
//		if( ndigit(F)==1 ) break ;
		if( B>MaxPrime ) break ;
	}
//		if( F==1 || F==-1 ) break ;

//	if( F<0 ) ~F ;

//	  T=D/(S*S) ;



//if( S*S*T!=D ) {
// Error(S*T!=D) ;
//}
//cout << endl << " max prime " << primes[k-1] << " square " << len10(S) << " not square " << len10(T);
//cout << " max prime " << mm ;
	delete [] primes ;
	delete [] index ;
}


